<?php
/*
    [123imagestock] (C)2006-2007 123imagestock Software. All Rights Reserved.
    This is NOT a freeware, use is subject to license terms
*/
class KeywordService
    {

    // database object
    var $_db   = null;
    var $error = null;
    var $table_prefix = null;

    function __construct($db, $table_prefix)
        {
        $this->_db         =$db;
        $this->table_prefix=$table_prefix;
        }

    public function del($ids)
        {
        foreach ($ids as $id)
            {
            if (!$this->isReferred($id))
                {
                $sql   ="delete from " . $this->table_prefix . "keywords where keyword_id = '$id'";
                $result=$this->_db->query($sql);
                }
            }
        }

    public function listKeywords()
        {
        $sql     ="select *,(select count(*) from " . $this->table_prefix
            . "images where image_keyword_ids like concat('%,',kw.keyword_id,',%')) as num FROM " . $this->table_prefix
            . "keywords kw order by num desc";
        $result  =$this->_db->query($sql);
        $keywords=$this->_db->fetch_all($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $keywords;
        }

    public function searchIdByText($text)
        {
        $sql   ="select keyword_id from " . $this->table_prefix . "keywords where keyword_text ='" . $text . "'";
        $result=$this->_db->query($sql);
        $id    =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $id['keyword_id'];
        }

    public function searchTextById($id)
        {
        $sql   ="select keyword_text from " . $this->table_prefix . "keywords where keyword_id ='" . $id . "'";
        $result=$this->_db->query($sql);
        $id    =$this->_db->fetch_array($result, MDB_FETCHMODE_ASSOC);
        $this->_db->free_result($result);
        return $id['keyword_text'];
        }

    public function exist($text)
        {
        $sql="select * from " . $this->table_prefix . "keywords where keyword_text ='" . $text . "'";
        return $this->_db->not_empty($sql);
        }

    public function insert($text)
        {
        $sql   ="insert into " . $this->table_prefix . "keywords(keyword_text) values ('" . $text . "')";
        $result=$this->_db->query($sql);
        $id    =$this->_db->get_insert_id();
        return $id;
        }

    private function isReferred($keywordId)
        {
        $sql="select * from " . $this->table_prefix . "images where image_keyword_ids like '%," . $keywordId . ",%'";
        return $this->_db->not_empty($sql);
        }
    }
?>